import os
import numpy as np

total_iteration_a = 10
total_iteration_b = 10
total_iteration = total_iteration_a * total_iteration_b
iteration = 1
iteration_flag = True
training_history = np.zeros(22)
for i in range(total_iteration_a):
    for j in range(total_iteration_b):
        a = 0.001 * (i + 1)
        b = 0.0005 * (j + 1)
        # スクリプトファイルのディレクトリの絶対パスを取得
        script_directory_path = os.path.dirname(__file__)
        from control_main import control_main

        # 0；Step　1；Ramp　2；PID　3；Ramp2Step　5；Sin_Wave　6；FEL　７；三角波
        control_condition = 2
        # 制御を行う対象の筋肉　0；BICのみ　1；TRIのみ　2；BICとTRI
        target_muscle = 0
        
        # 時間刻み step;5 pid,FEL;20 ramp;25
        TIME_STEP = 1e-4 * 20

        # BICとTRIの入力の最大値
        excitation_BIC_max = 0.2
        excitation_TRI_max = 0.08

        # シミュレーションの初めに入力を何も与えない(excitation=0.01)時間を作って平衡状態にする。
        quiet_time = 1
        # シミュレーショントータル時間(制御時間＋quite_time)　Step；5秒+quite_time　Ramp；20秒+quite_time　PID,FEL-FES；28秒
        end_time = 221

        # モデル一覧
        models = ["default", "type1", "fat", "thin", "powerful", "weak", "athletic", "sedentary", "elderly", 'Aftest', "tendontest"]
        # 使用するモデルの種類
        model_type = models[1]
        # 使用するモデルのファイル名
        model_file_name = "arm26.osim"
        # 使用するモデルのディレクトリ
        model_folder_name = "{}/../../model/{}".format(script_directory_path, model_type)
        # 使用するInitialStateのファイル名
        IniSta_file_name = "InitialState.sto"
        # 使用するInitialStateのディレクトリ
        IniSta_folder_name = model_folder_name

        # シミュレーション結果のexcelファイルの出力先のフォルダ名
        new_folder_name = "0606"
        # シミュレーション結果のexcelファイルの出力先のディレクトリ
        result_folder_name = "Results/{}".format(new_folder_name)

        # 追従実験の目標角度波形
        target_pattern = 5

        # Sin_Wage入力の時のパラメータ
        if control_condition == 5:
            end_time = 20 + 7 # 平衡時間に7秒
        zero_point = 0.06 # 正弦波の真ん中の座標
        amplitude = 0.05 # 正弦波の振幅
        period = 10 # 周期
        frequency = 1 / period # 周波数

        bug_flag, training_history = control_main(control_condition, target_muscle, target_pattern, quiet_time, end_time, excitation_BIC_max, excitation_TRI_max, zero_point, amplitude, frequency, model_file_name, model_folder_name, IniSta_file_name, IniSta_folder_name, result_folder_name, iteration_flag, iteration, total_iteration, training_history, TIME_STEP, a, b)
        iteration += 1