import os
import numpy as np
from datetime import datetime
from control_main import control_main

# スクリプトファイルのディレクトリの絶対パスを取得
script_directory_path = os.path.dirname(__file__)
# 日付を取得
now = datetime.now()
day = now.strftime("%m%d")
# 試行数
total_iteration = 1
iteration = 1
i = iteration - 1
training_history = np.zeros(22)
while i < total_iteration:
    # 0；Step　1；Ramp　2；PID　3；Ramp2Step　5；Sin_Wave　6；FEL　７；三角波　8；fuzzy
    control_condition = 2
    # 制御を行う対象の筋肉　0；BICのみ　1；TRIのみ(CHR法用)　2；BICとTRI
    target_muscle = 0
    # 時間刻み step;5 pid,FEL;20 ramp;25
    TIME_STEP = 1e-4 * 5
    # シミュレーションの初めに入力を何も与えない(excitation=0.01)時間を作って平衡状態にする。 三角波：1秒
    quiet_time = 1
    # シミュレーショントータル時間(制御時間＋quite_time)　Step；5秒+quite_time　Ramp；20秒+quite_time　PID,FEL-FES；28秒　三角波；22秒
    end_time = 20
    # モデル               0               1        2      3        4          5         6           7            8         9           10           11          12
    models = ["default(TRI_not_fixed)", "type1", "fat", "thin", "powerful", "weak", "athletic", "sedentary", "elderly", 'Aftest', "tendontest", "testmodel", "default"]
    # 使用するモデルの種類
    model_type = models[12]
    # Flag
    plot_flag = False
    recruitment_flag = False
    iteration_flag = True
    ANN_training_flag = True
    excitation_frequency_flag = False
    SES_flag = False
    delay_flag = True
    Flags = [iteration_flag, plot_flag, ANN_training_flag, excitation_frequency_flag, SES_flag, recruitment_flag, delay_flag]
    # 追従実験の目標角度波形 5；ランダム波 6；ステップ
    target_pattern = 4
    # ランダム波の時の周期 0；小 1；中 2；大 3；任意 4；ランダム
    target_period = 0
    # リクルートメント特性
    # 0：sigmoid　1：log　2：二次関数　3：三次関数　4：一次遅れ系　5：tanh　6：√　7：sin^2　8：default
    recruitment_pattern = 4
    # sigmoidのパラメーター
    sh_REC = 10
    xc = 0.5
    # 0：poor　1：medium　2：good
    PID_perf = 3

    if target_muscle != 1:
        # 使用するモデルのファイル名
        model_file_name = "arm26.osim"
        # 使用するInitialStateのファイル名
        IniSta_file_name = "InitialState.sto"
    elif target_muscle == 1:
        # 使用するモデルのファイル名
        model_file_name = "arm26_for_TRI_PID.osim"
        # 使用するInitialStateのファイル名
        IniSta_file_name = "InitialState_for_TRI_PID.sto"
    # 使用するモデルのディレクトリ
    model_folder_name = f"{script_directory_path}/../../model/{model_type}"
    # 使用するInitialStateのディレクトリ
    IniSta_folder_name = model_folder_name
    # シミュレーション結果のexcelファイルの出力先のフォルダ名
    new_folder_name = "{}/{}".format(day, model_type)
    # シミュレーション結果のexcelファイルの出力先のディレクトリ
    if target_period == 0:
        span = "short"
    elif target_period == 1:
        span = "medium"
    elif target_period == 2:
        span = "long"
    if PID_perf == 0:
        performance = "poor"
    elif PID_perf == 1:
        performance = "medium"
    elif PID_perf == 2:
        performance = "good"
    else:
        performance = None
    if recruitment_pattern == 0:
        recruit_name = "sigmoid"
    elif recruitment_pattern == 1:
        recruit_name = "log"
    elif recruitment_pattern == 2:
        recruit_name = "x^2"
    elif recruitment_pattern == 3:
        recruit_name = "x^3"
    elif recruitment_pattern == 4:
        recruit_name = "1次遅れ系"
    elif recruitment_pattern == 5:
        recruit_name = "tanh"
    elif recruitment_pattern == 6:
        recruit_name = "sqrt"
    elif recruitment_pattern == 7:
        recruit_name = "sin^2x"
    elif not recruitment_flag or recruitment_pattern == 8:
        recruit_name = "default"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}/{model_type}/for_CHR/0.7_15/TRI"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}/{model_type}/PID"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/0709/{model_type}/{span}/{xc}_{sh_REC}/{span}_事前あり_0.7_5"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/0709/{model_type}/{span}/{xc}_{sh_REC}/{span}_{performance}_事前なし"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}/{model_type}/center_moderate/事前無し"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}/{model_type}/for_PID"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/0709/{model_type}/{span}/{xc}_{sh_REC}/{span}_事前なし2"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}/nonlinear"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/0801/FEL/{recruit_name}/事前あり_1次遅れ系"
    result_folder_name = f"//Fesback/fes/Ryusuke_Yokoya/M2/osim/Results/{day}"
    ANN_forder_name = f"ANN_{span}_{xc}_{sh_REC}_{performance}"
    ANN_forder_name = f"ANN_{span}_{xc}_{sh_REC}"
    ANN_forder_name = f"ANN"
    ANN_forder_name = f"ANN_{recruit_name}"

    # PIDパラメーター
    # default 遅れ無し
    PID_paras_default_BIC = [0.28658910483018335, 0.48312854373915975, 0.011770462075924547]
    PID_paras_default_TRI = [-0.451607540911566, -2.0767583542786556, -0.011265404393685494]
    # default 遅れ追加
    PID_paras_default_BIC = [0.08417063061391614, 0.1418938595717341, 0.011874023566262973]
    PID_paras_default_TRI = [-0.09057346751106038, -0.4165095972212584, -0.011298588020468233]
    # default 遅れ追加(tuning)
    PID_paras_default_BIC = [0.08417063061391614, 0.1418938595717341, 0.02]
    PID_paras_default_TRI = [-0.09057346751106038, -0.4165095972212584, -0.011298588020468233]
    # default 遅れ追加 TRI修正(model12)
    PID_paras_default_BIC_default = [0.08682830327529971, 0.13899539588728427, 0.012275017407228604]
    PID_paras_default_TRI_default = [-0.2220589095546153, -0.45324827419485486, -0.02742409622126497]
    PID_paras_default_TRI_default = [-0.08682830327529971, -0.13899539588728427, -0.012275017407228604]
    PID_paras_default_BIC_sigmoid = [0.03514896624296119, 0.056265410391171694, 0.0049649061603600055]
    PID_paras_default_TRI_sigmoid = [-0.100382084513388, -0.2048959336920373, -0.012385258337302462]
    PID_paras_default_BIC_log = [0.08258302466999703, 0.13219952221317868, 0.011674857473049059]
    PID_paras_default_TRI_log = [-0.21787083350320846, -0.44469991985814183, -0.026906872206943183]
    PID_paras_default_TRI_log = [-0.08258302466999703, -0.13219952221317868, -0.011674857473049059]
    PID_paras_default_BIC_x2 = [0.09771557489027695, 0.1564238215408193, 0.013814163556006209]
    PID_paras_default_TRI_x2 = [-0.21675935477535097, -0.4424312614367521, -0.026769605480551573]
    PID_paras_default_TRI_x2 = [-0.09771557489027695, -0.1564238215408193, -0.013814163556006209]
    PID_paras_default_BIC_x3 = [0.08104251738911726, 0.12174961592210937, 0.0162844972553373]
    PID_paras_default_TRI_x3 = [-0.15744655564271683, -0.38342274633931304, -0.025619482299207852]
    PID_paras_default_TRI_x3 = [-0.08104251738911726, -0.12174961592210937, -0.0162844972553373]
    PID_paras_default_BIC_first_order_delay = [0.07940917256988946, 0.12711879608470167, 0.011226166340006125]
    PID_paras_default_TRI_first_order_delay = [-0.2044588404956712, -0.4173244693690247, -0.02525050188838512]
    PID_paras_default_TRI_first_order_delay = [-0.07940917256988946, -0.12711879608470167, -0.011226166340006125]
    PID_paras_default_BIC_tanh = [0.07181374297541401, 0.11495997570477569, 0.01015239169544172]
    PID_paras_default_TRI_tanh = [-0.1876883673960596, -0.383093967178971, -0.023179361987345624]
    PID_paras_default_TRI_tanh = [-0.07181374297541401, -0.11495997570477569, -0.01015239169544172]
    PID_paras_default_BIC_sqrt = [0.08827820506993986, 0.1413164095008374, 0.01247999169667833]
    PID_paras_default_TRI_sqrt = [-0.24611811014342036, -0.5023559239048148, -0.030395388088263114]
    PID_paras_default_TRI_sqrt = [-0.08827820506993986, -0.1413164095008374, -0.01247999169667833]
    PID_paras_default_BIC_sine_squared = [0.06925154192199427, 0.11085838513662044, 0.009790170376526536]
    PID_paras_default_TRI_sine_squared = [-0.1700536928902175, -0.34709952857800547, -0.021001493909685996]
    PID_paras_default_TRI_sine_squared = [-0.06925154192199427, -0.11085838513662044, -0.009790170376526536]
    PID_paras_default_BIC_05_5 = [0.24087783689378225, 0.40396514367701947, 0.009816400057349635]
    PID_paras_default_TRI_05_5 = [-0.33886770117597054, -1.5598430876077887, -0.008312762117174573]
    PID_paras_default_BIC_05_5_poor = [0.07, 0.09, 0.002]
    PID_paras_default_TRI_05_5_poor = [-0.05, -0.4, -0.003]
    PID_paras_default_BIC_05_5_medium = [0.117, 0.14, 0.002]
    PID_paras_default_TRI_05_5_medium = [-0.08, -0.5, -0.003]
    PID_paras_default_BIC_05_5_good = [0.23, 0.32, 0.006]
    PID_paras_default_TRI_05_5_good = [-0.2, -1, -0.006]
    PID_paras_default_BIC_05_10 = [0.224054351843594, 0.37770038458977545, 0.009176712819488368]
    PID_paras_default_TRI_05_10 = [-0.30097602448251576, -1.3840921874711674, -0.007413499116401571]
    PID_paras_default_BIC_05_10_poor = [0.035, 0.057, 0.001]
    PID_paras_default_TRI_05_10_poor = [-0.04, -0.2, -0.003]
    PID_paras_default_BIC_05_10_medium = [0.059, 0.07, 0.002]
    PID_paras_default_TRI_05_10_medium = [-0.06, -0.3, -0.004]
    PID_paras_default_BIC_05_10_good = [0.12, 0.2, 0.004]
    PID_paras_default_TRI_05_10_good = [-0.1, -0.4, -0.006]
    PID_paras_default_BIC_05_15 = [0.2204750230796573, 0.3716741492184299, 0.009054931420972799]
    PID_paras_default_TRI_05_15 = [-0.2931176375873503, -1.3479259900393454, -0.007252975629162431]
    PID_paras_default_BIC_05_15_poor = [0.022, 0.047, 0.002]
    PID_paras_default_TRI_05_15_poor = [-0.03, -0.15, -0.003]
    PID_paras_default_BIC_05_15_medium = [0.036, 0.066, 0.003]
    PID_paras_default_TRI_05_15_medium = [-0.06, -0.18, -0.004]
    PID_paras_default_BIC_05_15_good = [0.06, 0.33, 0.004]
    PID_paras_default_TRI_05_15_good = [-0.2, -0.2, -0.005]
    PID_paras_default_BIC_07_5 = [0.3319389789478593, 0.5476910027934443, 0.013591887042039744]
    PID_paras_default_TRI_07_5 = [-0.41157117062716847, -1.9345322432299326, -0.01014279736062085]
    PID_paras_default_BIC_07_5_poor = [0.07, 0.09, 0.002]
    PID_paras_default_TRI_07_5_poor = [-0.05, -0.4, -0.003]
    PID_paras_default_BIC_07_5_medium = [0.117, 0.14, 0.002]
    PID_paras_default_TRI_07_5_medium = [-0.08, -0.5, -0.003]
    PID_paras_default_BIC_07_5_good = [0.24, 0.32, 0.006]
    PID_paras_default_TRI_07_5_good = [-0.2, -1, -0.006]
    PID_paras_default_BIC_07_10 = [0.2942882975773671, 0.4955516271469292, 0.012087626858284954]
    PID_paras_default_TRI_07_10 = [-0.37072485776732567, -1.7068465591127724, -0.00917467686871196]
    PID_paras_default_BIC_07_10_poor = [0.0389, 0.056, 0.001]
    PID_paras_default_TRI_07_10_poor = [-0.04, -0.2, -0.003]
    PID_paras_default_BIC_07_10_medium = [0.059, 0.08, 0.002]
    PID_paras_default_TRI_07_10_medium = [-0.06, -0.3, -0.004]
    PID_paras_default_BIC_07_10_good = [0.12, 0.2, 0.004]
    PID_paras_default_TRI_07_10_good = [-0.1, -0.4, -0.006]
    PID_paras_default_BIC_07_15 = [0.28594261154917466, 0.4820116956928627, 0.011743985440039954]
    PID_paras_default_TRI_07_15 = [-0.36011677118310387, -1.6561257301916819, -0.008911181976396234]
    PID_paras_default_BIC_07_15_poor = [0.026, 0.05, 0.002]
    PID_paras_default_TRI_07_15_poor = [-0.04, -0.17, -0.003]
    PID_paras_default_BIC_07_15_medium = [0.038, 0.065, 0.003]
    PID_paras_default_TRI_07_15_medium = [-0.07, -0.2, -0.004]
    PID_paras_default_BIC_07_15_good = [0.065, 0.29, 0.004]
    PID_paras_default_TRI_07_15_good = [-0.2, -0.25, -0.005]
    PID_paras_type1_before_tuning_BIC = [0.21725388137889728, 0.3068688319798013, 0.01861378741795764]
    PID_paras_type1_after_tuning_BIC = [0.4, 0.32, 0.055]
    PID_paras_type1_after_2_tuning_BIC = [0.342066348229353, 0.100255925488534, 0.0315559120026774]
    PID_paras_fat_BIC = [0.3486460487462016, 0.5436771340179911, 0.01777178078514276]
    PID_paras_fat_TRI = [-0.490709090526893, -2.112923046524607, -0.015100779776435706]
    PID_paras_thin_BIC = [0.3019422931665838, 0.5014424977068221, 0.012865473029892868]
    PID_paras_thin_TRI = [-0.45898349881671885, -2.020668633372157, -0.012243110483846142]
    PID_paras_powerful_BIC = [0.23368698412236125, 0.45033028915149037, 0.008389487458518924]
    PID_paras_powerful_TRI = [-0.40850811762139283, -2.0928513874668555, -0.008723368547722845]
    PID_paras_weak_BIC = [0.4677238679113438, 0.6563630121793718, 0.023018725345428315]
    PID_paras_weak_TRI = [-0.5732871058926027, -2.2931464879265833, -0.01776890858891384]
    PID_paras_athletic_BIC = [0.24731750712708644, 0.47715546200785525, 0.009137064565322345]
    PID_paras_athletic_TRI = [-0.42633184562748605, -2.14344620182043, -0.00946040601064495]
    PID_paras_sedentary_BIC = [0.3615360581081641, 0.5414716504214276, 0.016611369957764976]
    PID_paras_sedentary_TRI = [-0.5116591904910404, -2.104998945069465, -0.01448750511733199]
    PID_paras_elderly_BIC = [0.3747639140836035, 0.5556632027270828, 0.01731832290641401]
    PID_paras_elderly_TRI = [-0.5171948942905795, -2.092758207600287, -0.014988918400155178]

    excitation_BIC_max = 0.01
    excitation_TRI_max = 0.01
    excitation_BIC_min = 0.01
    excitation_TRI_min = 0.01
    params_BIC = [None, None, None]
    params_TRI = [None, None, None]
    
    # 入力設定
    if model_type == "default(TRI_not_fixed)":
        excitation_BIC_max = 0.14
        excitation_TRI_max = 0.15
        excitation_BIC_min = 0.01
        excitation_TRI_min = 0.01
        if not recruitment_flag:
            params_BIC = PID_paras_default_BIC
            params_TRI = PID_paras_default_TRI
        else:
            if sh_REC == 5 and xc == 0.5:
                params_BIC = PID_paras_default_BIC_05_5
                params_TRI = PID_paras_default_TRI_05_5
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_05_5_poor
                    params_TRI = PID_paras_default_TRI_05_5_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_05_5_medium
                    params_TRI = PID_paras_default_TRI_05_5_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_05_5_good
                    params_TRI = PID_paras_default_TRI_05_5_good
            elif sh_REC == 10 and xc == 0.5:
                params_BIC = PID_paras_default_BIC_05_10
                params_TRI = PID_paras_default_TRI_05_10
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_05_10_poor
                    params_TRI = PID_paras_default_TRI_05_10_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_05_10_medium
                    params_TRI = PID_paras_default_TRI_05_10_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_05_10_good
                    params_TRI = PID_paras_default_TRI_05_10_good
            elif sh_REC == 15 and xc == 0.5:
                params_BIC = PID_paras_default_BIC_05_15
                params_TRI = PID_paras_default_TRI_05_15
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_05_15_poor
                    params_TRI = PID_paras_default_TRI_05_15_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_05_15_medium
                    params_TRI = PID_paras_default_TRI_05_15_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_05_15_good
                    params_TRI = PID_paras_default_TRI_05_15_good
            elif sh_REC == 5 and xc == 0.7:
                params_BIC = PID_paras_default_BIC_07_5
                params_TRI = PID_paras_default_TRI_07_5
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_07_5_poor
                    params_TRI = PID_paras_default_TRI_07_5_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_07_5_medium
                    params_TRI = PID_paras_default_TRI_07_5_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_07_5_good
                    params_TRI = PID_paras_default_TRI_07_5_good
            elif sh_REC == 10 and xc == 0.7:
                params_BIC = PID_paras_default_BIC_07_10
                params_TRI = PID_paras_default_TRI_07_10
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_07_10_poor
                    params_TRI = PID_paras_default_TRI_07_10_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_07_10_medium
                    params_TRI = PID_paras_default_TRI_07_10_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_07_10_good
                    params_TRI = PID_paras_default_TRI_07_10_good
            elif sh_REC == 15 and xc == 0.7:
                params_BIC = PID_paras_default_BIC_07_15
                params_TRI = PID_paras_default_TRI_07_15
                if PID_perf == 0:
                    params_BIC = PID_paras_default_BIC_07_15_poor
                    params_TRI = PID_paras_default_TRI_07_15_poor
                elif PID_perf == 1:
                    params_BIC = PID_paras_default_BIC_07_15_medium
                    params_TRI = PID_paras_default_TRI_07_15_medium
                elif PID_perf == 2:
                    params_BIC = PID_paras_default_BIC_07_15_good
                    params_TRI = PID_paras_default_TRI_07_15_good
    elif model_type == "default":
        excitation_BIC_max = 0.14
        excitation_TRI_max = 0.15
        excitation_BIC_min = 0.01
        excitation_TRI_min = 0.01
        params_BIC = PID_paras_default_BIC_default
        params_TRI = PID_paras_default_TRI_default
        if recruitment_pattern == 0:
            params_BIC = PID_paras_default_BIC_sigmoid
            params_TRI = PID_paras_default_TRI_sigmoid
        elif recruitment_pattern == 1:
            params_BIC = PID_paras_default_BIC_log
            params_TRI = PID_paras_default_TRI_log
        elif recruitment_pattern == 2:
            params_BIC = PID_paras_default_BIC_x2
            params_TRI = PID_paras_default_TRI_x2
        elif recruitment_pattern == 3:
            params_BIC = PID_paras_default_BIC_x3
            params_TRI = PID_paras_default_TRI_x3
        elif recruitment_pattern == 4:
            params_BIC = PID_paras_default_BIC_first_order_delay
            params_TRI = PID_paras_default_TRI_first_order_delay
        elif recruitment_pattern == 5:
            params_BIC = PID_paras_default_BIC_tanh
            params_TRI = PID_paras_default_TRI_tanh
        elif recruitment_pattern == 6:
            params_BIC = PID_paras_default_BIC_sqrt
            params_TRI = PID_paras_default_TRI_sqrt
        elif recruitment_pattern == 7:
            params_BIC = PID_paras_default_BIC_sine_squared
            params_TRI = PID_paras_default_TRI_sine_squared
    elif model_type == "type1":
        excitation_BIC_max = 0.14
        excitation_TRI_max = 0.08
        params_BIC = PID_paras_type1_before_tuning_BIC
    elif model_type == "fat":
        excitation_BIC_max = 0.20
        excitation_TRI_max = 0.18
        params_BIC = PID_paras_fat_BIC
        params_TRI = PID_paras_fat_TRI
    elif model_type == "thin":
        excitation_BIC_max = 0.155
        excitation_TRI_max = 0.16
        params_BIC = PID_paras_thin_BIC
        params_TRI = PID_paras_thin_TRI
    elif model_type == "powerful":
        excitation_BIC_max = 0.115
        excitation_TRI_max = 0.13
        params_BIC = PID_paras_powerful_BIC
        params_TRI = PID_paras_powerful_TRI
    elif model_type == "weak":
        excitation_BIC_max = 0.21
        excitation_TRI_max = 0.2
        params_BIC = PID_paras_weak_BIC
        params_TRI = PID_paras_weak_TRI
    elif model_type == "athletic":
        excitation_BIC_max = 0.13
        excitation_TRI_max = 0.14
        params_BIC = PID_paras_athletic_BIC
        params_TRI = PID_paras_athletic_TRI
    elif model_type == "sedentary":
        excitation_BIC_max = 0.175
        excitation_TRI_max = 0.17
        params_BIC = PID_paras_sedentary_BIC
        params_TRI = PID_paras_sedentary_TRI
    elif model_type == "elderly":
        excitation_BIC_max = 0.18
        excitation_TRI_max = 0.175
        params_BIC = PID_paras_elderly_BIC
        params_TRI = PID_paras_elderly_TRI

    recruitment_paras = [sh_REC, xc]

    # Sin_Wage入力の時のパラメータ
    if control_condition == 4:
        end_time = 20 + 7 # 平衡時間に7秒
    zero_point = 0.06 # 正弦波の真ん中の座標
    amplitude = 0.05 # 正弦波の振幅
    period = 10 # 周期
    frequency = 1 / period # 周波数

    bug_flag, training_history = control_main(control_condition, target_muscle, target_pattern, quiet_time, end_time, excitation_BIC_max, excitation_TRI_max, excitation_BIC_min, excitation_TRI_min, zero_point, amplitude, frequency, model_file_name, model_folder_name, IniSta_file_name, IniSta_folder_name, result_folder_name, iteration, total_iteration, training_history, TIME_STEP, params_BIC, params_TRI, Flags, target_period, recruitment_paras, ANN_forder_name, recruitment_pattern)
    if not bug_flag:
        iteration += 1
        i += 1