def PID_controller(target_angle, this_angle, last_error, last_integral_error, pid_params, time_step, excitation_max, excitation_min):
    kp, ki, kd = pid_params
    this_error = target_angle - this_angle
    this_integral_error = last_integral_error + this_error * time_step
    excitation_kp = kp * this_error
    excitation_ki = ki * this_integral_error
    excitation_kd = kd * (this_error - last_error) / time_step
    excitation_pid = excitation_kp + excitation_ki + excitation_kd
    if excitation_pid > excitation_max:
        this_integral_error = last_integral_error
        excitation_pid = excitation_max
    elif excitation_pid < excitation_min:
        this_integral_error = last_integral_error
        excitation_pid = excitation_min
    return excitation_pid, this_error, this_integral_error